#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<pair<ll, ll>> g;
vector<ll> sz;
vector<ll> par;
vector<ll> type;

void dfs(ll v, ll p, ll t) {
    par[v] = p;
    sz[v] = 1;
    type[v] = t;
    if (g[v].first != -1) {
        dfs(g[v].first, v, 0);
        sz[v] += sz[g[v].first];
    }
    if (g[v].second != -1) {
        dfs(g[v].second, v, 1);
        sz[v] += sz[g[v].second];
    }
}

ll get_size(ll v) {
    if (v == -1) {
        return 0;
    } else {
        return sz[v];
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    g = vector<pair<ll, ll>>(n);
    for (ll i = 0; i < n; i++) {
        cin >> g[i].first >> g[i].second;
        g[i].first--;
        g[i].second--;
    }
    sz.assign(n, 0);
    par.assign(n, -1);
    type.assign(n, 0);
    dfs(0, -1, 0);
    vector<ll> tree(n, -1);
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            l--;
            for (ll i = l; i < r; i++) {
                tree[i] = x;
            }
        } else {
            ll v;
            cin >> v;
            v--;
            ll ans;
            ll res = tree[v];
            if (res == -1) {
                ans = 0;
            } else if (res == 0) {
                ans = get_size(g[v].first);
            } else {
                ans = get_size(g[v].first) + get_size(g[v].second);
            }
            while (v != 0) {
                if (type[v] == 0) {
                    if (tree[par[v]] == -1) {
                        ans++;
                    }
                } else {
                    ans += get_size(g[par[v]].first);
                    if (tree[par[v]] != 1) {
                        ans++;
                    }
                }
                v = par[v];
            }
            cout << ans + 1 << '\n';
        }
    }
}
