#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> col(1000001, -1);
vector<vector<ll>> g(1000001);

void dfs(ll v, ll color) {
    col[v] = color;
    for (auto &to: g[v]) {
        if (col[to] == -1) {
            dfs(to, 1 - color);
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    vector<ll> prime(1000001);
    for (ll i = 2; i <= 1000000; i++) {
        prime[i] = i;
    }
    for (ll i = 2; i <= 1000000; i++) {
        if (prime[i] == i) {
            for (ll j = i * i; j <= 1000000; j += i) {
                if (i < prime[j]) {
                    prime[j] = i;
                }
            }
        }
    }
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (auto &i: a) {
        vector<ll> f;
        ll x = i;
        while (x > 1) {
            f.push_back(prime[x]);
            x /= prime[x];
        }
        f.resize(unique(f.begin(), f.end()) - f.begin());
        for (auto &p: f) {
            g[i].push_back(i / p);
            g[i / p].push_back(i);
        }
    }
    for (ll i = 0; i <= 1000000; i++) {
        if (col[i] == -1) {
            dfs(i, 0);
        }
    }
    for (auto &i: a) {
        cout << col[i] + 1 << ' ';
    }
}
