#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<ll> cnt(m + 1);
    for (ll i = 0; i < n; i++) {
        ll a;
        cin >> a;
        cnt[a - 1]++;
    }
    for (ll i = 0; i < m - 2; i++) {
        ll x = (cnt[i] % 3 + 3) % 3;
        cnt[i] -= x;
        cnt[i + 1] -= x;
        cnt[i + 2] -= x;
    }
    for (ll i = 0; i < m; i++) {
        if (cnt[i] < 0) {
            cout << 0;
            return 0;
        }
    }
    if (cnt[m - 2] % 3 != 0) {
        cout << 0;
        return 0;
    }
    if (cnt[m - 1] % 3 != 0) {
        cout << 0;
        return 0;
    }
    for (ll i = 0; i <= m; i++) {
        cnt[i] /= 3;
    }
    if (m <= 2) {
        cout << 1;
        return 0;
    } else if (m == 3) {
        cout << min(cnt[0], min(cnt[1], cnt[2])) + 1;
    } else if (m == 4) {
        ll ans = 0;
        for (ll x1 = 0; x1 <= n; x1++) {
            for (ll x2 = 0; x2 <= n; x2++) {
                if (cnt[0] >= x1 && cnt[1] >= x1 + x2 && cnt[2] >= x1 + x2 && cnt[3] >= x2) {
                    ans++;
                }
            }
        }
        cout << ans;
    } else if (n <= 500 && m <= 500) {
        ll mx_cnt = 0;
        for (ll i = 0; i < m; i++) {
            if (cnt[i] > mx_cnt) {
                mx_cnt = cnt[i];
            }
        }
        vector<vector<vector<int>>> dp(m, vector<vector<int>>(mx_cnt + 1, vector<int>(mx_cnt + 1)));
        for (int x1 = 0; x1 <= mx_cnt; x1++) {
            for (int x2 = 0; x2 <= mx_cnt; x2++) {
                dp[1][x1][x2] = 1;
            }
        }
        for (int i = 2; i < m; i++) {
            for (int x1 = 0; x1 <= mx_cnt; x1++) {
                for (int x2 = 0; x2 <= mx_cnt; x2++) {
                    dp[i][x1][x2] = 0;
                    for (int x = 0; x <= min(cnt[i - 2], min(cnt[i - 1] - x1, cnt[i] - x2)); x++) {
                        dp[i][x1][x2] = (dp[i][x1][x2] + dp[i - 1][x][x1 + x]) % mod;
                    }
                }
            }
        }
        cout << dp[m - 1][0][0];
    } else {
        ll ans = 1;
        for (ll i = 0; i + 3 <= m; i += 4) {
            ans = (ans * (min(cnt[i], min(cnt[i + 1], cnt[i + 2])) + 1)) % mod;
        }
        cout << ans;
    }
}