#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<ll> cnt(m + 1);
    for (ll i = 0; i < n; i++) {
        ll a;
        cin >> a;
        cnt[a - 1]++;
    }
    for (ll i = 0; i < m - 2; i++) {
        ll x = (cnt[i] % 3 + 3) % 3;
        cnt[i] -= x;
        cnt[i + 1] -= x;
        cnt[i + 2] -= x;
    }
    for (ll i = 0; i < m; i++) {
        if (cnt[i] < 0) {
            cout << 0;
            return 0;
        }
    }
    if (cnt[m - 2] % 3 != 0) {
        cout << 0;
        return 0;
    }
    if (cnt[m - 1] % 3 != 0) {
        cout << 0;
        return 0;
    }
    for (ll i = 0; i <= m; i++) {
        cnt[i] /= 3;
    }
    vector<vector<vector<ll>>> dp(m, vector<vector<ll>>(n + 1, vector<ll>(n + 1)));
    for (ll x1 = 0; x1 <= n; x1++) {
        for (ll x2 = 0; x2 <= n; x2++) {
            dp[1][x1][x2] = 1;
        }
    }
    for (ll i = 2; i < m; i++) {
        for (ll x1 = 0; x1 <= n; x1++) {
            for (ll x2 = 0; x2 <= n; x2++) {
                dp[i][x1][x2] = 0;
                for (ll x = 0; x <= min(cnt[i - 2], min(cnt[i - 1] - x1, cnt[i] - x2)); x++) {
                    dp[i][x1][x2] = (dp[i][x1][x2] + dp[i - 1][x][x1 + x]) % mod;
                }
            }
        }
    }
    cout << dp[m - 1][0][0];
}