#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, q;
vector<pair<ll, ll>> g;
vector<ll> sz;
vector<ll> par;
vector<ll> type;

void dfs(ll v, ll p, ll t) {
    par[v] = p;
    sz[v] = 1;
    type[v] = t;
    if (g[v].first != -1) {
        dfs(g[v].first, v, 0);
        sz[v] += sz[g[v].first];
    }
    if (g[v].second != -1) {
        dfs(g[v].second, v, 1);
        sz[v] += sz[g[v].second];
    }
}

ll get_size(ll v) {
    if (v == -1) {
        return 0;
    } else {
        return sz[v];
    }
}

vector<ll> tree1;
vector<ll> o;
vector<ll> ans2;

void foo(ll v) {
    if (tree1[v] == -1) {
        o.push_back(v);
    }
    if (g[v].first != -1) {
        foo(g[v].first);
    }
    if (tree1[v] == 0) {
        o.push_back(v);
    }
    if (g[v].second != -1) {
        foo(g[v].second);
    }
    if (tree1[v] == 1) {
        o.push_back(v);
    }
}

void foo1() {
    foo(0);
    for (ll i = 0; i < n; i++) {
        ans2[o[i]] = i;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> q;
    g = vector<pair<ll, ll>>(n);
    for (ll i = 0; i < n; i++) {
        cin >> g[i].first >> g[i].second;
        g[i].first--;
        g[i].second--;
    }
    sz.assign(n, 0);
    par.assign(n, -1);
    type.assign(n, 0);
    dfs(0, -1, 0);
    vector<vector<ll>> queries(q);
    ll q1 = 0;
    for (ll i = 0; i < q; i++) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            l--;
            queries[i] = {t, l, r, x};
            q1++;
        } else {
            ll v;
            cin >> v;
            v--;
            queries[i] = {t, v};
        }
    }
    if (q1 <= 10) {
        tree1.assign(n, -1);
        ans2.assign(n, -1);
        foo1();
        for (auto &query: queries) {
            ll t = query[0];
            if (t == 1) {
                ll l = query[1], r = query[2], x = query[3];
                for (ll i = l; i < r; i++) {
                    tree1[i] = x;
                }
                o.clear();
                foo1();
            } else {
                ll v = query[1];
                cout << ans2[v] + 1 << '\n';
            }
        }
    } else {
        tree1.assign(n, -1);
        for (auto &query: queries) {
            ll t = query[0];
            if (t == 1) {
                ll l = query[1], r = query[2], x = query[3];
                for (ll i = l; i < r; i++) {
                    tree1[i] = x;
                }
            } else {
                ll v = query[1];
                ll ans;
                ll res = tree1[v];
                if (res == -1) {
                    ans = 0;
                } else if (res == 0) {
                    ans = get_size(g[v].first);
                } else {
                    ans = get_size(g[v].first) + get_size(g[v].second);
                }
                while (v != 0) {
                    if (type[v] == 0) {
                        if (tree1[par[v]] == -1) {
                            ans++;
                        }
                    } else {
                        ans += get_size(g[par[v]].first);
                        if (tree1[par[v]] != 1) {
                            ans++;
                        }
                    }
                    v = par[v];
                }
                cout << ans + 1 << '\n';
            }
        }
    }
}
